#!/usr/bin/perl

$n = 0;
$x2_tot = 0; $x4_tot = 0;
#
# read in the data
#
while(<>)
{
    @line = split;
    $x2[$n] = $line[0]**2;
    $x4[$n] = $x2[$n]**2;
    $x2_tot += $x2[$n];
    $x4_tot+= $x4[$n];
    $n++;
}
#
# Do the jackknife averages
#
for ($i = 0; $i < $n; $i++)
{
    $x2_jack[$i] = ($x2_tot - $x2[$i]) / ($n - 1);
    $x4_jack[$i] = ($x4_tot - $x4[$i]) / ($n - 1);
}
$x2_av = $x2_tot / $n;
$x4_av = $x4_tot / $n;
$g_av = $x4_av / $x2_av**2;

$g_jack_av = 0; $g_jack_err = 0;
for ($i = 0; $i < $n; $i++)
{
    $dg = $x4_jack[$i] / $x2_jack[$i]**2;
    $g_jack_av += $dg;
    $g_jack_err += $dg**2;
}
$g_jack_av /= $n;
$g_jack_err /= $n;
$g_jack_err = sqrt(($n - 1) * abs($g_jack_err - $g_jack_av**2));

printf " Overall average is   %8.4f\n", $g_av;
printf " Jackknife average is %8.4f +/- %6.4f \n", $g_jack_av, $g_jack_err;
