from pylab import *
from scipy.optimize import leastsq

fname = sys.argv[1] if len(sys.argv) > 1 else 'data.txt'
x, y, err = np.loadtxt(fname, unpack=True)
n = len(x)

resids = lambda p: (p[0] + p[1]*x - y) / err
p0 = [5., 0.1]  # initial values of parameters

p, covm = leastsq(resids, p0, full_output=True)[:2]
c, m = p
errc, errm = sqrt(diag(covm))
chisq = sum(resids(p)**2)
chisq /= n - 2

print "slope     = %10.4f +/- %7.4f " % (m, errm)
print "intercept = %10.4f +/- %7.4f \n" % (c, errc)
print "chi squared / NDF = %7.4lf " % chisq

