from pylab import *
from scipy.optimize import leastsq
from scipy.stats import chi2

fname = sys.argv[1] if len(sys.argv) > 1 else 'data.txt'
L, Ts, Tserr = np.loadtxt(fname, unpack=True)
n = len(L)

def resids(p):
    Tc, w, A = p
    return (Tc + A/L**w - Ts) / Tserr

p0 = [-0.25, 0.2, 2.8]

p, covm = leastsq(resids, p0, full_output=True)[:2]
Tc, w, A = p
Tcerr, werr, Aerr = sqrt(diag(covm))
chisq = sum(resids(p)**2)
ndf = n - len(p)
Q = 1. - chi2.cdf(chisq, ndf)

print 'Tc = %10.4f +/- %7.4f' % (Tc, Tcerr)
print 'A  = %10.4f +/- %7.4f' % (A, Aerr)
print 'w  = %10.4f +/- %7.4f' % (w, werr)
print 'chi squared / NDF = %7.4lf' % (chisq / ndf)
print 'Q  = %10.4f' % Q

